;A simle effect that "sucks" the screen into the middle
;		--By Levi Lansing--
;       --Email ME! puzzlesome@hotmail.com
;You are free to do as you wish with this program EXCEPT you may
;  not put your name on it and call it your own!  DUH!
;***************************************************************

#include "ti86asm.inc"

.org _asm_exec_ram

 call _runindicoff		;turn it off!!!
 ld ix,Pic
 call decompV			;decompress and display the pic...
 call _getkey			;wait for a key press



;********************************************************************
;if you are using this routine in your program, copy from here to....
;********************************************************************

ScreenEffect:
 ld b,64			;b = 64 (counts across the columns)
Start:
 push bc			;hide b for later (and c too)

 ld hl,$FC00		;point hl to the begining of the display memory
 ld de,$8			;8 bytes left to skip on each line after the rotation
 ld b,64			;64 lines to move
TLloop1:
 push bc			;hide b and c
 ld b,8				;8 bytes per half row (64 cols)
 xor a				;a = 0
 rra				;clear the carry flag
TLloop:
 ld a,(hl)			;pull a byte from the screen
 rra				;rotate it right (into the carry flag)
 ld (hl),a			;put the rotation back onto the screen
 inc hl				;point to the next byte
 djnz TLloop
 add hl,de			;move hl to the next row
 pop bc				;restore the most recently pushed bc
 djnz TLloop1		;loop 64 times


 ld hl,$FC0F		;points to the end of the first row of the display mem
 ld de,$18			;since we have to move backwards, we have to skip nearly 2 rows
 ld b,64			;64 rows
TRloop1:
 push bc
 ld b,8				;8 bytes per half row
 xor a				;clear a
 rla				;rotate a left to clear the cary flag
TRloop:
 ld a,(hl)			;get byte from screen
 rla				;rotate it left
 ld (hl),a			;put the rotated byte back
 dec hl				;point hl to the previous byte
 djnz TRloop		;loop until the end of the row
 add hl,de			;point hl to the end of the next row
 pop bc
 djnz TRloop1		;loop 64 times (64 cols to move through)

 pop bc
 djnz Start			;loop 64 times to clear the whole screen!
 ret

;*********************************************************************
;copy to here and leave the "ret" to return from a call or the program
;*********************************************************************




;********************************************************
; -decompresses data that is vertically compressed with
; pic2db, by Levi Lansing
; -(decompresses data into the video memory - 1024 bytes)
; -ix=location of data to decompress
; -destroys- a,b,c,de,hl,ix (points to byte after data)
;********************************************************
decompV:
 xor a
 ld de,16
 ld hl,$FC00
decompLoop:
 ld a,(ix)
 cp $B7
 jr nz,DCnorm
 inc ix
 ld a,(ix)
 ld c,a
 inc ix
 ld a,(ix)
 ld b,a
 inc ix
DCrepeatLoop:
 ld (hl),c
 add hl,de
 jr nc,DCloop
 push de
 ld de,1022
 sbc hl,de
 pop de
 ld a,l
 cp $10
 jr nz,DCloop
 ret
DCloop:
 djnz DCrepeatLoop
 jr decompLoop
DCnorm:
 ld (hl),a
 inc ix
 add hl,de
 jr nc,decompLoop
 push de
 ld de,1022
 sbc hl,de
 pop de
 ld a,l
 cp $10
 jr nz,decompLoop
 ret
;***this decompression routine only costs 68 bytes for an average of 60-70%
;   compresion of a picture!***


Pic:		;data for the picture to copy to the screen

;Compressed picutre made with BMP to ASM by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 295 bytes - 71% compressed!
  .db $B7, $FF, $67, $00, $00, $B7, $3F, $06, $03, $03, $B7, $3F, $06, $00, $00, $B7
  .db $FF, $0A, $B7, $00, $04, $B7, $F8, $0E, $B7, $00, $04, $B7, $FF, $2A, $B7, $00
  .db $04, $B7, $1F, $0E, $B7, $00, $04, $B7, $FF, $0E, $00, $00, $B7, $3F, $06, $01
  .db $01, $B7, $3F, $08, $B7, $FF, $6E, $00, $00, $B7, $3F, $06, $01, $01, $B7, $3F
  .db $08, $B7, $FF, $0C, $B7, $3F, $10, $00, $00, $FF, $FF, $FF, $FC, $C0, $00, $87
  .db $B7, $FF, $29, $FE, $FE, $B7, $FC, $0A, $FE, $FE, $7F, $7F, $FF, $FF, $03, $00
  .db $1C, $7F, $B7, $FF, $0A, $00, $00, $B7, $3F, $06, $03, $03, $B7, $3F, $06, $00
  .db $00, $B7, $FF, $0C, $83, $01, $38, $7C, $B7, $FE, $09, $7E, $7C, $38, $01, $83
  .db $FF, $FF, $FF, $7F, $0F, $80, $F0, $B7, $FF, $0B, $FE, $FE, $FE, $B7, $FC, $08
  .db $FE, $FE, $FE, $B7, $FF, $0E, $B7, $FE, $04, $7E, $B7, $7F, $09, $B7, $FF, $06
  .db $FC, $F8, $E0, $00, $03, $B7, $FF, $09, $83, $01, $38, $7C, $7C, $B7, $FF, $08
  .db $FC, $7C, $38, $01, $83, $B7, $FF, $0C, $B7, $7C, $04, $78, $38, $39, $39, $39
  .db $31, $B7, $93, $04, $83, $C7, $C7, $C7, $FF, $80, $00, $0F, $7F, $B7, $FF, $0B
  .db $F8, $F8, $B7, $FF, $2F, $0F, $01, $E0, $FC, $B7, $FF, $0B, $00, $00, $B7, $CF
  .db $10, $B7, $FF, $0C, $00, $00, $B7, $3F, $06, $03, $03, $B7, $3F, $06, $00, $00
  .db $FF, $FF, $F9, $60, $00, $03, $B7, $FF, $0A, $7F, $7F, $B7, $FE, $05, $B7, $FF
  .db $06, $FE, $FC, $FE, $B7, $FF, $30, $83, $01, $38, $7D, $7F, $7F, $3F, $0F, $87
  .db $E1, $F1, $F8, $FC, $FC, $7C, $39, $01, $87, $B7, $FF, $2E, $B7, $FC, $0D, $FF
  .db $FF, $FC, $FC, $FC, $B7, $FF, $47

.end		;all done!
